//////////////////////////////////////////////
//											//
// Encryption/Decryption Code Generator		//
// Author       : Themelis Christos			//	
// Created      : 02/02/2001				//
//											//
//////////////////////////////////////////////

// Use on of the follow functions to generate your code 
// Input : You must put your input to Al
// void MakeByteCode(void)
// Output : The new value is in Al

// Input : You must put your input to Ax
// void MakeWordCode(void)
// Output : The new value is in Ax

// Input : You must put your input to EAx
// void MakeDWordCode(void)
// Output : The new value is in EAx

// The result of this function is 2 files 
// 1) Encryption.C
// 2) Decryption.C

// Example for your code (Encryption 1 Byte):
// _asm { Mov Al, MyValue }
// #include "Encrypt.c"
// _asm { Mov MyValue, Al }

// Example for your code (Decryption 4 Byte):
// _asm { Mov EAx, MyValue }
// #include "Decrypt.c"
// _asm { Mov MyValue, EAx }

#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <conio.h>

//variables

int   MaxLines, BytesToUse;
DWORD MaxCmd, MaxReg, PushPopSP, MainSP, MainSPX;
char  MyCommand[20][15];
char  MyCommandX[20][15];
char  MyRegister[20][4];
DWORD MyOpCodes[100][10];
WORD  MyMoves[10][10];
BYTE  MyPush[10];
DWORD MaxOfCmd[20];
char *MainBuffer;
char *MainBufferX;
char *PushBuffer;
char *PopBuffer;

char *ExternalBuffer;
FILE *h1, *h2, *h3;

int i, j, k, IdxCmd, IdxReg, OldFreq, Freq, OldCmd, MySp, LastXchg, Xchg, CmdSp;
char MyInput[4];
int ArrayOfReg[20];
char Pushs[10][10];
char TmpCmds[50][50];
char TmpCmdsX[50][50];
char TmpCmd[50];
char TmpInput[50];	
boolean AddNow;
DWORD MyValue, x;
char MyVal[5];
char TmpStr[10];

//functions

void  GenerateCode(void);
DWORD InitRegisters(void);
DWORD InitCommands(void);
DWORD Random(DWORD MyMin, DWORD MyMax);
void  MyMemCpy(char *Dest, char *Source, DWORD MyCount);
void  InitOpCode(void);

//DLL export
__declspec( dllexport ) int MakeCode(char *MyExternalBuffer, int MyBufferSize, int MyBytesToUse);

DWORD Random(DWORD MyMin, DWORD MyMax)
{
	DWORD x;
	x = MyMin + (rand() % (MyMax - MyMin) );		
	if (MyMax > 0xFFFF) { x = x * x; }
	return x;
}

//Here is the array that i keep the opcodes in binary format
void InitOpCode(void)
{
	MyOpCodes[0][0] = 0x05;   // Add EAx
	MyOpCodes[0][1] = 0x81C1; // Add Ecx
	MyOpCodes[0][2] = 0x81C2; // Add EDx
	MyOpCodes[0][3] = 0x81C3; // Add EBx
	MyOpCodes[0][4] = 0x81C5; // Add EBp
	MyOpCodes[0][5] = 0x81C6; // Add ESi
	MyOpCodes[0][6] = 0x81C7; // Add EDi

	MyOpCodes[1][0] = 0x2D;   // Sub EAx
	MyOpCodes[1][1] = 0x81E9; // Sub Ecx
	MyOpCodes[1][2] = 0x81EA; // Sub EDx
	MyOpCodes[1][3] = 0x81EB; // Sub EBx
	MyOpCodes[1][4] = 0x81ED; // Sub EBp
	MyOpCodes[1][5] = 0x81EE; // Sub ESi
	MyOpCodes[1][6] = 0x81EF; // Sub EDi

	MyOpCodes[2][0] = 0xC1C8; // Ror EAx
	MyOpCodes[2][1] = 0xC1C9; // Ror Ecx
	MyOpCodes[2][2] = 0xC1CA; // Ror EDx
	MyOpCodes[2][3] = 0xC1CB; // Ror EBx
	MyOpCodes[2][4] = 0xC1CD; // Ror EBp
	MyOpCodes[2][5] = 0xC1CE; // Ror ESi
	MyOpCodes[2][6] = 0xC1CF; // Ror EDi

	MyOpCodes[3][0] = 0xC1C0; // Rol EAx
	MyOpCodes[3][1] = 0xC1C1; // Rol Ecx
	MyOpCodes[3][2] = 0xC1C2; // Rol EDx
	MyOpCodes[3][3] = 0xC1C3; // Rol EBx
	MyOpCodes[3][4] = 0xC1C5; // Rol EBp
	MyOpCodes[3][5] = 0xC1C6; // Rol ESi
	MyOpCodes[3][6] = 0xC1C7; // Rol EDi

	MyOpCodes[4][0] = 0x35;   // Xor EAx
	MyOpCodes[4][1] = 0x81F1; // Xor Ecx
	MyOpCodes[4][2] = 0x81F2; // Xor EDx
	MyOpCodes[4][3] = 0x81F3; // Xor EBx
	MyOpCodes[4][4] = 0x81F5; // Xor EBp
	MyOpCodes[4][5] = 0x81F6; // Xor ESi
	MyOpCodes[4][6] = 0x81F7; // Xor EDi

	MyOpCodes[5][0] = 0x35;   // Xor EAx
	MyOpCodes[5][1] = 0x81F1; // Xor Ecx
	MyOpCodes[5][2] = 0x81F2; // Xor EDx
	MyOpCodes[5][3] = 0x81F3; // Xor EBx
	MyOpCodes[5][4] = 0x81F5; // Xor EBp
	MyOpCodes[5][5] = 0x81F6; // Xor ESi
	MyOpCodes[5][6] = 0x81F7; // Xor EDi

	MyMoves[0][0] = 0;		// Mov EAx, EAx 
	MyMoves[0][1] = 0x8BC1;	// Mov EAx, ECx 
	MyMoves[0][2] = 0x8BC2; // Mov EAx, EDx 
	MyMoves[0][3] = 0x8BC3; // Mov EAx, EBx 
	MyMoves[0][4] = 0x8BC5; // Mov EAx, EBp 
	MyMoves[0][5] = 0x8BC6; // Mov EAx, ESi 
	MyMoves[0][6] = 0x8BC7; // Mov EAx, EDi 

	MyMoves[1][0] = 0x8BC8; // Mov ECx, EAx 
	MyMoves[1][1] = 0;		// Mov ECx, ECx 
	MyMoves[1][2] = 0x8BCA; // Mov ECx, EDx 
	MyMoves[1][3] = 0x8BCB; // Mov ECx, EBx 
	MyMoves[1][4] = 0x8BCD; // Mov ECx, EBp 
	MyMoves[1][5] = 0x8BCE; // Mov ECx, ESi 
	MyMoves[1][6] = 0x8BCF; // Mov ECx, EDi 

	MyMoves[2][0] = 0x8BD0; // Mov EDx, EAx 
	MyMoves[2][1] = 0x8BD1; // Mov EDx, ECx 
	MyMoves[2][2] = 0;		// Mov EDx, EDx 
	MyMoves[2][3] = 0x8BD3; // Mov EDx, EBx 
	MyMoves[2][4] = 0x8BD5; // Mov EDx, EBp 
	MyMoves[2][5] = 0x8BD6; // Mov EDx, ESi 
	MyMoves[2][6] = 0x8BD7; // Mov EDx, EDi 

	MyMoves[3][0] = 0x8BD8; // Mov EBx, EAx 
	MyMoves[3][1] = 0x8BD9; // Mov EBx, ECx 
	MyMoves[3][2] = 0x8BDA; // Mov EBx, EDx 
	MyMoves[3][3] = 0;		// Mov EBx, EBx 
	MyMoves[3][4] = 0x8BDD; // Mov EBx, EBp 
	MyMoves[3][5] = 0x8BDE; // Mov EBx, ESi 
	MyMoves[3][6] = 0x8BDF; // Mov EBx, EDi 

	MyMoves[4][0] = 0x8BE8; // Mov EBp, EAx 
	MyMoves[4][1] = 0x8BE9; // Mov EBp, ECx 
	MyMoves[4][2] = 0x8BEA; // Mov EBp, EDx 
	MyMoves[4][3] = 0x8BEB; // Mov EBp, EBx 
	MyMoves[4][4] = 0;      // Mov EBp, EBp 
	MyMoves[4][5] = 0x8BEE; // Mov EBp, ESi 
	MyMoves[4][6] = 0x8BEF; // Mov EBp, EDi 

	MyMoves[5][0] = 0x8BF0; // Mov ESi, EAx 
	MyMoves[5][1] = 0x8BF1; // Mov ESi, ECx 
	MyMoves[5][2] = 0x8BF2; // Mov ESi, EDx 
	MyMoves[5][3] = 0x8BF3; // Mov ESi, EBx 
	MyMoves[5][4] = 0x8BF5; // Mov ESi, EBp 
	MyMoves[5][5] = 0;		// Mov ESi, ESi 
	MyMoves[5][6] = 0x8BF7; // Mov ESi, EDi 

	MyMoves[6][0] = 0x8BF8; // Mov EDi, EAx 
	MyMoves[6][1] = 0x8BF9; // Mov EDi, ECx 
	MyMoves[6][2] = 0x8BFA; // Mov EDi, EDx 
	MyMoves[6][3] = 0x8BFB; // Mov EDi, EBx 
	MyMoves[6][4] = 0x8BFD; // Mov EDi, EBp 
	MyMoves[6][5] = 0x8BFE; // Mov EDi, ESi 
	MyMoves[6][6] = 0;		// Mov EDi, EDi 

	MyPush[0] = 0x50; // Push EAx
	MyPush[1] = 0x51; // Push ECx
	MyPush[2] = 0x52; // Push EDx
	MyPush[3] = 0x53; // Push EBx
	MyPush[4] = 0x55; // Push EBp
	MyPush[5] = 0x56; // Push ESi
	MyPush[6] = 0x57; // Push EDi

	return;
}

//Here is the array that keeps the assembly commands, in case that you output is source code
DWORD InitCommands(void)
{
	DWORD MyMax = 4;
	strcpy(MyCommand[0], "Add");
	strcpy(MyCommand[1], "Sub");
	strcpy(MyCommand[2], "Ror");
	strcpy(MyCommand[3], "Rol");
	strcpy(MyCommand[4], "XOr");
	strcpy(MyCommandX[0], MyCommand[1]);
	strcpy(MyCommandX[1], MyCommand[0]);
	strcpy(MyCommandX[2], MyCommand[3]);
	strcpy(MyCommandX[3], MyCommand[2]);
	strcpy(MyCommandX[4], MyCommand[4]);	
	return MyMax;
}

//Here is the array for registers
DWORD InitRegisters(void)
{
	DWORD MyMax;

	switch (BytesToUse)
	{
	case 1 :
		{
		    MaxOfCmd[0] = 0xFF;
			MaxOfCmd[1] = 0xFF;
			MaxOfCmd[2] = 0xFF;
			MaxOfCmd[3] = 0xFF;
			MaxOfCmd[4] = 0xFF;
			MaxOfCmd[5] = 0xFF;
			MaxOfCmd[6] = 0xFF;
			MaxOfCmd[7] = 0xFF;
			strcpy(MyRegister[0], "Al");
			strcpy(MyRegister[1], "Ah");
			strcpy(MyRegister[2], "Bl");
			strcpy(MyRegister[3], "Bh");
			strcpy(MyRegister[4], "Cl");
			strcpy(MyRegister[5], "Ch");
			strcpy(MyRegister[6], "Dl");
			strcpy(MyRegister[7], "Dh");
			MyMax = 7;
			break;
		}	
	case 2 :
		{
		    MaxOfCmd[0] = 0xFFFF;
			MaxOfCmd[1] = 0xFFFF;
			MaxOfCmd[2] = 0xFF;
			MaxOfCmd[3] = 0xFF;
			MaxOfCmd[4] = 0xFFFF;
			MaxOfCmd[5] = 0xFFFF;
			MaxOfCmd[6] = 0xFFFF;
			strcpy(MyRegister[0], "Ax");			
			strcpy(MyRegister[1], "Bx");
			strcpy(MyRegister[2], "Cx");
			strcpy(MyRegister[3], "Dx");
			strcpy(MyRegister[4], "Si");
			strcpy(MyRegister[5], "Di");
			strcpy(MyRegister[6], "Bp");
			MyMax = 6;
			break;
		}	
	case 4 :
		{
		    MaxOfCmd[0] = 0xFFFFFFFF;
			MaxOfCmd[1] = 0xFFFFFFFF;
			MaxOfCmd[2] = 0xFF;
			MaxOfCmd[3] = 0xFF;
			MaxOfCmd[4] = 0xFFFFFFFF;
			MaxOfCmd[5] = 0xFFFFFFFF;
			MaxOfCmd[6] = 0xFFFFFFFF;
			strcpy(MyRegister[0], "EAx");			
			strcpy(MyRegister[1], "ECx");
			strcpy(MyRegister[2], "EDx");
			strcpy(MyRegister[3], "EBx");
			strcpy(MyRegister[4], "EBp");
			strcpy(MyRegister[5], "ESi");
			strcpy(MyRegister[6], "EDi");			
			MyMax = 6;
			break;
		}	
	}
	return MyMax;
}

//Here is the main function that generates the encryption / decryption algorithm
void GenerateCode(void)
{
	MainSP = MainSPX = 0;
	PushPopSP = 0;

	switch (BytesToUse)
	{
		case 1 : { strcpy(MyInput, "Al"); break; }
		case 2 : { strcpy(MyInput, "Ax"); break; }
		case 4 : { strcpy(MyInput, "EAx"); break; }
	}

	ArrayOfReg[0] = Random(0, MaxReg + 1);	
	for (i=1; i<20; i++)
	{
		ArrayOfReg[i] = ArrayOfReg[i-1];
		while ( ArrayOfReg[i] == ArrayOfReg[i-1] ) { ArrayOfReg[i] = Random(0, MaxReg + 1); }
	}

	IdxReg = MySp = 0;

	if (BytesToUse == 1) 
	{ 
		sprintf(TmpCmd, "%cx", MyRegister[ArrayOfReg[0]][0]); 
		sprintf(TmpInput, "%cx", MyInput[0]);
	}
	else 
	{ 
		strcpy(TmpCmd, MyRegister[ArrayOfReg[0]]); 
		strcpy(TmpInput, MyInput);
	}
	CmdSp = 0;
	if (strcmp(TmpCmd, TmpInput) != 0)
	{ 
		sprintf(TmpCmd, "Mov %s, %s", MyRegister[ArrayOfReg[0]], MyInput); 
		strcpy(TmpCmds[CmdSp], TmpCmd); 
		sprintf(TmpCmd, "Mov %s, %s", MyInput, MyRegister[ArrayOfReg[0]]); 
		strcpy(TmpCmdsX[CmdSp], TmpCmd); 
		
		memcpy((char*)&MainBufferX[MainSPX], (char*)&MyMoves[0][ArrayOfReg[0]], 2);
		MainSPX+=2;
		if (BytesToUse == 2) 
		{ 
			memset((char*)&MainBuffer[MainSP], 0x66, 1);
			memset((char*)&MainBufferX[MainSPX], 0x66, 1); 
			MainSP++; MainSPX++;
		}
		MyMemCpy((char*)&MainBuffer[MainSP], (char*)&MyMoves[ArrayOfReg[0]][0], 2);			
		MainSP+=2;
		
		CmdSp++;
		if (BytesToUse != 1)
		{
			strcpy(Pushs[0], MyRegister[ArrayOfReg[0]]);
			memset((char*)&PushBuffer[PushPopSP], MyPush[ArrayOfReg[0]], 1);
			memset((char*)&PopBuffer[PushPopSP], MyPush[ArrayOfReg[0]], 1);
			PushPopSP++;
		} else
		{
			sprintf(TmpCmd, "%cx", MyRegister[ArrayOfReg[0]][0]);
			strcpy(Pushs[0], TmpCmd);
		}
		MySp++;
	}

	Freq = Random(2, 5); 
	j = IdxCmd = 0;
	Xchg = 1;
	for (i=0; i<=MaxLines; i++)
	{
		j++;
		if (j == Freq) 
		{ 	
			LastXchg = Xchg;
			while (Xchg == LastXchg) { Xchg = Random(1, 2 + 1); }			
			switch ( Xchg )
			{				
				case 1 : 
					{ 
						sprintf(TmpCmd, "Mov %s, %s", MyRegister[ArrayOfReg[IdxReg+1]], MyRegister[ArrayOfReg[IdxReg]]); 
						strcpy(TmpCmds[CmdSp], TmpCmd); 
						sprintf(TmpCmd, "Mov %s, %s", MyRegister[ArrayOfReg[IdxReg]], MyRegister[ArrayOfReg[IdxReg+1]]); 
						strcpy(TmpCmdsX[CmdSp], TmpCmd); 

						memcpy((char*)&MainBufferX[MainSPX], (char*)&MyMoves[ArrayOfReg[IdxReg]][ArrayOfReg[IdxReg+1]], 2);
						MainSPX+=2;
						if (BytesToUse == 2) 
						{ 
							memset((char*)&MainBuffer[MainSP], 0x66, 1); 
							memset((char*)&MainBufferX[MainSPX], 0x66, 1); 
							MainSP++; MainSPX++;
						}
						MyMemCpy((char*)&MainBuffer[MainSP], (char*)&MyMoves[ArrayOfReg[IdxReg+1]][ArrayOfReg[IdxReg]], 2);						
						MainSP+=2;

						CmdSp++;
						break; 
					}
				case 2 : 
					{ 
						if (BytesToUse != 1) 
						{
							sprintf(TmpCmd, "Push %s\nPop %s", MyRegister[ArrayOfReg[IdxReg]], MyRegister[ArrayOfReg[IdxReg+1]]); 
							strcpy(TmpCmds[CmdSp], TmpCmd); 
							sprintf(TmpCmd, "Push %s\nPop %s", MyRegister[ArrayOfReg[IdxReg+1]], MyRegister[ArrayOfReg[IdxReg]]); 
							strcpy(TmpCmdsX[CmdSp], TmpCmd); 

							if (BytesToUse == 2)
							{ 
							  memset((char*)&MainBuffer[MainSP], 0x66, 1);
							  memset((char*)&MainBuffer[MainSP+1], MyPush[ArrayOfReg[IdxReg]], 1);
							  memset((char*)&MainBuffer[MainSP+2], 0x66, 1);
							  memset((char*)&MainBuffer[MainSP+3], MyPush[ArrayOfReg[IdxReg+1]] + 8, 1); 
							  
							  memset((char*)&MainBufferX[MainSPX], MyPush[ArrayOfReg[IdxReg]] + 8, 1); 
							  memset((char*)&MainBufferX[MainSPX+1], 0x66, 1);
							  memset((char*)&MainBufferX[MainSPX+2], MyPush[ArrayOfReg[IdxReg+1]], 1);
							  memset((char*)&MainBufferX[MainSPX+3], 0x66, 1);							  
							  MainSP+=4; MainSPX+=4;
							}
							else
							{ 
								memset((char*)&MainBuffer[MainSP], MyPush[ArrayOfReg[IdxReg]], 1);
								memset((char*)&MainBuffer[MainSP+1], MyPush[ArrayOfReg[IdxReg+1]] + 8, 1); 
								
								memset((char*)&MainBufferX[MainSPX+1], MyPush[ArrayOfReg[IdxReg+1]], 1);
								memset((char*)&MainBufferX[MainSPX], MyPush[ArrayOfReg[IdxReg]] + 8, 1); 
								
								MainSP+=2; MainSPX+=2;
							}

							CmdSp++;
						}
						else 
						{ 
							if (MyRegister[ArrayOfReg[IdxReg]][0] != MyRegister[ArrayOfReg[IdxReg+1]][0])
							{
								sprintf(TmpCmd, "Push %cx\nPop %cx", MyRegister[ArrayOfReg[IdxReg]][0], MyRegister[ArrayOfReg[IdxReg+1]][0]); 
								strcpy(TmpCmds[CmdSp], TmpCmd); 
								sprintf(TmpCmd, "Push %cx\nPop %cx", MyRegister[ArrayOfReg[IdxReg+1]][0], MyRegister[ArrayOfReg[IdxReg]][0]); 
								strcpy(TmpCmdsX[CmdSp], TmpCmd); 
								CmdSp++;
							}
							if (MyRegister[ArrayOfReg[IdxReg]][1] != MyRegister[ArrayOfReg[IdxReg+1]][1])
							{								
								sprintf(TmpCmd, "Xchg %ch, %cl", MyRegister[ArrayOfReg[IdxReg+1]][0], MyRegister[ArrayOfReg[IdxReg+1]][0]);
								strcpy(TmpCmdsX[CmdSp], TmpCmd); 
								strcpy(TmpCmds[CmdSp], TmpCmd); 
								CmdSp++;
							}
						}
						break; 
					}
			}
			
			IdxReg++;

			if (BytesToUse == 1) 
			{ sprintf(TmpCmd, "%cx", MyRegister[ArrayOfReg[IdxReg]][0]); }
			else 
			{ strcpy(TmpCmd, MyRegister[ArrayOfReg[IdxReg]]); }
			
			if (strcmp(TmpCmd, TmpInput) != 0)
			{
				AddNow = TRUE;
				for (k = 0; k <= MySp; k++)
				{
					if (strcmp(TmpCmd, Pushs[k]) == 0)
					{					
						AddNow = FALSE;
						break;
					}
				}
				if (AddNow)
				{	
					strcpy(Pushs[MySp], TmpCmd);

					memset((char*)&PushBuffer[PushPopSP], MyPush[ArrayOfReg[IdxReg]], 1);
					memset((char*)&PopBuffer[PushPopSP], MyPush[ArrayOfReg[IdxReg]], 1);
					PushPopSP++;

					MySp++;
				}
			}
			
			OldFreq = Freq;
			while (OldFreq == Freq) { Freq = Random(2, 5 + 1); }
			j=0; 
		}
		OldCmd = IdxCmd;
		while (OldCmd == IdxCmd) { IdxCmd = Random(0, MaxCmd + 1); }
		MyValue = Random(1, MaxOfCmd[IdxCmd]);
		sprintf(TmpCmd, "%s %s, 0%Xh", MyCommand[IdxCmd], MyRegister[ArrayOfReg[IdxReg]], MyValue);
		strcpy(TmpCmds[CmdSp], TmpCmd); 
		sprintf(TmpCmd, "%s %s, 0%Xh", MyCommandX[IdxCmd], MyRegister[ArrayOfReg[IdxReg]], MyValue);
		strcpy(TmpCmdsX[CmdSp], TmpCmd); 

		itoa(MaxOfCmd[IdxCmd], TmpStr, 16);
		memcpy((char*)&MyVal, &MyValue, (strlen(TmpStr) / 2));

		MyMemCpy((char*)&MainBufferX[MainSPX], &MyValue, (strlen(TmpStr) / 2));
		MainSPX += (strlen(TmpStr) / 2);
		
		if (BytesToUse == 2) 
		{ 
			memset((char*)&MainBuffer[MainSP], 0x66, 1); 
			MainSP++;
		}

		if (MyOpCodes[IdxCmd][ArrayOfReg[IdxReg]] > 0xFF)
		{
			if (MyOpCodes[IdxCmd][ArrayOfReg[IdxReg]] > 0xFFFF) 
			{ 
				MyMemCpy((char*)&MainBuffer[MainSP], (char*)&MyOpCodes[IdxCmd][ArrayOfReg[IdxReg]], 4); 
				if ((IdxCmd % 2) == 0) 
				{
					memcpy((char*)&MainBufferX[MainSPX], (char*)&MyOpCodes[IdxCmd+1][ArrayOfReg[IdxReg]], 4); 
				} else
				{
					memcpy((char*)&MainBufferX[MainSPX], (char*)&MyOpCodes[IdxCmd-1][ArrayOfReg[IdxReg]], 4); 
				} 
				MainSP+=4; MainSPX+=4;
			} else	
			{ 
				MyMemCpy((char*)&MainBuffer[MainSP], (char*)&MyOpCodes[IdxCmd][ArrayOfReg[IdxReg]], 2); 
				if ((IdxCmd % 2) == 0) 
				{
					memcpy((char*)&MainBufferX[MainSPX], (char*)&MyOpCodes[IdxCmd+1][ArrayOfReg[IdxReg]], 2); 
				} else
				{
					memcpy((char*)&MainBufferX[MainSPX], (char*)&MyOpCodes[IdxCmd-1][ArrayOfReg[IdxReg]], 2); 
				}
				MainSP+=2; MainSPX+=2;
			}
		} else
		{ 
			memset((char*)&MainBuffer[MainSP], MyOpCodes[IdxCmd][ArrayOfReg[IdxReg]], 1); 
			if ((IdxCmd % 2) == 0) 
			{
				memset((char*)&MainBufferX[MainSPX], MyOpCodes[IdxCmd+1][ArrayOfReg[IdxReg]], 1); 
			} else
			{
				memset((char*)&MainBufferX[MainSPX], MyOpCodes[IdxCmd-1][ArrayOfReg[IdxReg]], 1); 
			}
			MainSP++; MainSPX++; 
		}

		if (BytesToUse == 2) 
		{ 
			memset((char*)&MainBufferX[MainSPX], 0x66, 1); 
			MainSPX++;
		}
		
		for (x=0; x<(strlen(TmpStr) / 2); x++)
		{
			memset((char*)&MainBuffer[MainSP], MyVal[x], 1);
			MainSP++;
		}

		CmdSp++;
	}

	if (strcmp(MyRegister[ArrayOfReg[IdxReg]], MyInput) != 0)
	{ 
		sprintf(TmpCmd, "Mov %s, %s", MyInput, MyRegister[ArrayOfReg[IdxReg]]); 
		strcpy(TmpCmds[CmdSp], TmpCmd); 
		sprintf(TmpCmd, "Mov %s, %s", MyRegister[ArrayOfReg[IdxReg]], MyInput); 
		strcpy(TmpCmdsX[CmdSp], TmpCmd);

		memcpy((char*)&MainBufferX[MainSPX], (char*)&MyMoves[ArrayOfReg[IdxReg]][0], 2);
		MainSPX+=2;
		if (BytesToUse == 2) 
		{ 
			memset((char*)&MainBuffer[MainSP], 0x66, 1); 
			memset((char*)&MainBufferX[MainSPX], 0x66, 1); 
			MainSP++; MainSPX++; 
		}
		MyMemCpy((char*)&MainBuffer[MainSP], (char*)&MyMoves[0][ArrayOfReg[IdxReg]], 2);
		MainSP+=2;

		CmdSp++;
	}
	return;
}

void MyMemCpy(char *Dest, char *Source, DWORD MyCount)
{
	if ( MyCount == 0 )
	{
		return;
	}
	_asm
	{
		PushAD
		PushFD
		Mov    ECx, MyCount
		Mov    EDi, Dest
LoopAgain:
		Mov    ESi, Source		
		Add    ESi, ECx
		Dec    ESi
		MovSb
		Dec    ECx
		Jnz    LoopAgain
		PopFD
		PopAD
	}
	return;
}

//This function creates the necessary "push" and "pop" commands
void Push2Pop (char *PopBuffer, int PushPopSP)
{
	if ( PushPopSP == 0 ) 
	{
		return;
	}
	_asm
	{
		PushAD
		Mov    ECx, PushPopSP
		Mov    ESi, PopBuffer
		Mov    EDi, ESi
LoopAgain:
		LodSb
		Add    Al,  8
		StoSb
		Dec    ECx
		Cmp    ECx, 0
		Jne    LoopAgain
		PopAD
	}
	return;
}

//DLL export function (main)
__declspec( dllexport ) int MakeCode(char *MyExternalBuffer, int MyBufferSize, int MyBytesToUse)
{
	int TotalBytes;

	ExternalBuffer = MyExternalBuffer;
	BytesToUse = MyBytesToUse;	

	MainBuffer  = malloc(500);	
	MainBufferX = malloc(500);
	PushBuffer  = malloc(500);
	PopBuffer   = malloc(500);		

	memset(MainBuffer, 0, 500);
	memset(MainBufferX, 0, 500);
	memset(PushBuffer, 0, 500);
	memset(PopBuffer, 0, 500);

	MaxLines = Random(10, 30 + 1);

	MaxCmd = InitCommands();
	MaxReg = InitRegisters();
	InitOpCode();
	
	GenerateCode();

	if (ExternalBuffer != NULL)
	{
		TotalBytes = ( PushPopSP * 2 ) + MainSP;
		if (TotalBytes < MyBufferSize)
		{
			memcpy(ExternalBuffer, PushBuffer, PushPopSP);
			memcpy(ExternalBuffer + PushPopSP, MainBuffer, MainSP);
			Push2Pop(PopBuffer, PushPopSP);
			MyMemCpy(ExternalBuffer + PushPopSP + MainSP, PopBuffer, PushPopSP);

			memset(ExternalBuffer + TotalBytes, 0xC3, 1);
			TotalBytes++;
			
			memcpy(ExternalBuffer + TotalBytes, PushBuffer, PushPopSP);
			MyMemCpy(ExternalBuffer + TotalBytes + PushPopSP, MainBufferX, MainSP);
			MyMemCpy(ExternalBuffer + TotalBytes + PushPopSP + MainSP, PopBuffer, PushPopSP);

			memset(ExternalBuffer + (TotalBytes * 2) - 1, 0xC3, 1);
			memset(ExternalBuffer + (TotalBytes * 2), 0x90, 1);
		}
	}
	else
	{
		h1 = fopen("Encrypt.c", "w");
		h2 = fopen("Decrypt.c", "w");
		fprintf(h1, "_asm\n{\n");
		fprintf(h2, "_asm\n{\n");
		for (k=0; k<MySp; k++)     { fprintf(h1, "Push %s\n", Pushs[k]); fprintf(h2, "Push %s\n", Pushs[k]); }
		for (k=0; k<CmdSp; k++)    { fprintf(h1, "%s\n", TmpCmds[k]); }
		for (k=CmdSp-1; k>=0; k--) { fprintf(h2, "%s\n", TmpCmdsX[k]); }
		for (k=MySp-1; k>=0; k--)  { fprintf(h1, "Pop %s\n", Pushs[k]); fprintf(h2, "Pop %s\n", Pushs[k]); }
		fprintf(h1, "}\n");
		fprintf(h2, "}\n");
		fclose(h2);
		fclose(h1);
	}

	free(MainBuffer);
	free(MainBufferX);
	free(PushBuffer);
	free(PopBuffer);

	return TotalBytes;
}

BOOL WINAPI DllMain(
	  HINSTANCE hinstDLL,  // handle to DLL module
	  DWORD fdwReason,     // reason for calling function
	  LPVOID lpvReserved   // reserved
	)
	{
		srand( time(0) );

		return TRUE;
	}


